using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ForestField : BackGroundBase
{
	public override int FieldId => 1;

	public ForestField(string bgmId = "NONE")
		: base(bgmId)
	{
	}

	protected override void BattleFieldBuild()
	{
		BattleCoroutine.GetInstance().StartCoroutine(BackGroundBase.ObjectChecker(0.5f, _str3DFieldPath, delegate
		{
			base.Field = GameObject.Find(_str3DFieldPath);
			base.Field.transform.parent = GameMgr.GetIns().m_GameManagerObj.transform;
			GimicAudioList = base.Field.GetComponent<AudioList>().GimicAudioList;
			_fieldModel = base.Field.transform.Find("md_bf_frst_root").gameObject;
			_fieldParticles = _fieldModel.transform.Find("Particles01").gameObject;
			_fieldObjDictionary.Add(_fieldParticles.name, _fieldParticles);
			_fieldObjDictionary.Add("mainTree_door", _fieldModel.transform.Find("md_bf_frst_01_mainTree_door").gameObject);
			_fieldObjDictionary.Add("moveBranch_a", _fieldModel.transform.Find("md_bf_frst_01_moveBranch_a").gameObject);
			_fieldObjDictionary.Add("moveBranch_b", _fieldModel.transform.Find("md_bf_frst_01_moveBranch_b").gameObject);
			m_FieldAnimatorDictionary.Add("mainTree_door", _fieldObjDictionary["mainTree_door"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("moveBranch_a", _fieldObjDictionary["moveBranch_a"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("moveBranch_b", _fieldObjDictionary["moveBranch_b"].GetComponent<Animator>());
			_fieldParticleSystemDictionary.Add("leaf", _fieldParticles.transform.Find("leaf").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("tree_gimic_1", _fieldParticles.transform.Find("tree_gimic_1").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("tree_gimic_2", _fieldParticles.transform.Find("tree_gimic_2").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("fairy_opening", _fieldParticles.transform.Find("fairy_opening").GetComponent<ParticleSystem>());
			List<string> list = new List<string>(_fieldObjDictionary.Keys);
			List<GameObject> list2 = new List<GameObject>();
			for (int i = 0; i < _fieldObjDictionary.Count; i++)
			{
				list2.Add(_fieldObjDictionary[list[i]]);
			}
			GameMgr.GetIns().GetEffectMgr().SetUIParticleShader(list2, delegate
			{
				base.SetShaderGlobalColorBG = base.Field.transform.Find("SetMaterialColorBGManager").GetComponent<SetShaderGlobalColorBG>();
				base.IsLoadDone = true;
			}, isBattle: true, isField: true);
		}));
	}

	public override void StartFieldSetEffect(Vector3 pos)
	{
		GameMgr.GetIns().GetEffectMgr().Start(EffectMgr.EffectType.CMN_FIELD_SET_1, pos);
	}

	public override void StartFieldTapEffect(int areaId, Vector3 pos)
	{
		base.StartFieldTapEffect(areaId, pos);
		switch (areaId)
		{
		case 1:
			GameMgr.GetIns().GetEffectMgr().Start(EffectMgr.EffectType.CMN_FIELD_TAP_1_1, pos);
			break;
		case 2:
			GameMgr.GetIns().GetEffectMgr().Start(EffectMgr.EffectType.CMN_FIELD_TAP_1_2, pos);
			break;
		}
	}

	protected override IEnumerator RunFieldOpening()
	{
		GameMgr.GetIns().GetSoundMgr().PlaySeByStr($"se_field_{_str3DFieldNo}_appear_1", "se_field_" + _str3DFieldNo, 0f, 0L);
		_fieldParticleSystemDictionary["fairy_opening"].Play();
		m_FieldAnimatorDictionary["mainTree_door"].SetTrigger("OpenFast");
		_battleCamera.Camera.transform.localPosition = new Vector3(-660f, 200f, -150f);
		_battleCamera.Camera.transform.localRotation = Quaternion.Euler(new Vector3(-15f, -90f, 90f));
		iTween.MoveTo(_battleCamera.Camera.gameObject, iTween.Hash("position", new Vector3(-500f, 10f, -20f), "time", 2f, "islocal", true, "easetype", iTween.EaseType.easeInOutQuad));
		iTween.RotateTo(_battleCamera.Camera.gameObject, iTween.Hash("rotation", new Vector3(-40f, -90f, 90f), "time", 2f, "islocal", true, "easetype", iTween.EaseType.easeInOutQuad));
		yield return new WaitForSeconds(2f);
		m_FieldAnimatorDictionary["mainTree_door"].SetTrigger("CloseFast");
		GameMgr.GetIns().GetSoundMgr().PlaySe(Se.TYPE.SYS_CAMERA_ZOOM_OUT);
		iTween.MoveTo(_battleCamera.Camera.gameObject, iTween.Hash("position", new Vector3(-150f, -50f, -100f), "time", 1f, "islocal", true, "easetype", iTween.EaseType.easeInExpo));
		iTween.RotateTo(_battleCamera.Camera.gameObject, iTween.Hash("rotation", new Vector3(-30f, -20f, 25f), "time", 1f, "islocal", true, "easetype", iTween.EaseType.easeInExpo));
		iTween.MoveTo(_battleCamera.Camera.gameObject, iTween.Hash("position", _battleCamera.BattleCameraPos, "time", 1f, "delay", 1f, "islocal", true, "easetype", iTween.EaseType.easeOutExpo));
		iTween.RotateTo(_battleCamera.Camera.gameObject, iTween.Hash("rotation", _battleCamera.BattleCameraRot, "time", 1f, "delay", 1f, "islocal", true, "easetype", iTween.EaseType.easeOutExpo));
		yield return new WaitForSeconds(0f);
	}

	protected override IEnumerator RunFieldGimic(GameObject obj)
	{
		string tag = obj.tag;
		if (tag != null && tag == "FieldGimic1" && _gimicCntDictionary[obj.tag] == 0)
		{
			_gimicCntDictionary[obj.tag]++;
			m_FieldAnimatorDictionary["mainTree_door"].SetTrigger("Open");
			int rnd = Random.Range(1, 3);
			GameMgr.GetIns().GetSoundMgr().PlaySeByStr($"se_field_{_str3DFieldNo}_gim_{rnd}", "se_field_" + _str3DFieldNo, 0f, 0L);
			yield return new WaitForSeconds(1.5f);
			switch (rnd)
			{
			case 1:
				_fieldParticleSystemDictionary["tree_gimic_1"].Play();
				break;
			case 2:
				_fieldParticleSystemDictionary["tree_gimic_2"].Play();
				break;
			}
			yield return new WaitForSeconds(1f);
			m_FieldAnimatorDictionary["mainTree_door"].SetTrigger("Close");
			yield return new WaitForSeconds(3f);
			_gimicCntDictionary[obj.tag] = 0;
		}
		yield return new WaitForSeconds(0f);
	}

	protected override IEnumerator RunFieldShake()
	{
		_fieldParticleSystemDictionary["leaf"].Play();
		m_FieldAnimatorDictionary["moveBranch_a"].speed = 1f + Random.value * 0.5f;
		m_FieldAnimatorDictionary["moveBranch_a"].SetTrigger("Shake");
		m_FieldAnimatorDictionary["moveBranch_b"].speed = 1f + Random.value * 0.5f;
		m_FieldAnimatorDictionary["moveBranch_b"].SetTrigger("Shake");
		yield return new WaitForSeconds(0f);
	}
}
